package com.btc.ep.core;

import java.util.HashMap;
import java.util.Map;

import org.osgi.util.tracker.ServiceTracker;

import com.btc.ep.core.impl.Activator;

@SuppressWarnings({ "rawtypes", "unchecked" })
public class Services {
	
	private static Map<String, ServiceTracker> trackers = new HashMap<>();

	private static Map<Class, Object> testServices = new HashMap<>();

	private static ServiceTracker getServiceTracker(Class serviceClass) {
		
		String clazz = serviceClass.getName();
		
		ServiceTracker st = trackers.get(clazz); 
		if (st == null) {
			st = new ServiceTracker(Activator.getContext(), clazz, null);
			st.open();
			trackers.put(clazz, st);
		}
		
		return st;
	}
	
	public static <T> T get(Class<T> serviceClass) {
		Object service = testServices.get(serviceClass);
		if (service == null) {
			service = getServiceTracker(serviceClass).getService();
		}
		return (T)service;
	}

	public static void addOverride(Class serviceClass, Object serviceImplementation) {
		testServices.put(serviceClass, serviceImplementation);
    }

    public static void clearOverrides() {
    	testServices.clear();
    } 
}
