package optimisticlockwithremove.dmo.impl;

import java.util.UUID;
import java.util.concurrent.atomic.AtomicLong;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Transient;

import optimisticlockwithremove.dmo.ModelElement;

@Entity
@Access (AccessType.FIELD)
public abstract class ModelElementImpl implements ModelElement {

    @Id
    private String uid = UUID.randomUUID().toString();

    protected ModelElementImpl() {
    }

    @Override
    public String getUid() {
    
        return this.uid;
    }

    @Override
    public int hashCode() {
        return getUid().hashCode();
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof ModelElement) {
            return this.getUid().equals(((ModelElement)obj).getUid());
        }

        return super.equals(obj);
    }

    @Override
    public String getURI() {
        throw new UnsupportedOperationException();
    }
}
