package optimisticlockwithremove.dmo.impl;

import java.util.LinkedHashSet;
import java.util.Set;
import java.util.function.Predicate;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import optimisticlockwithremove.dmo.Architecture;
import optimisticlockwithremove.dmo.InterfaceObject;
import optimisticlockwithremove.dmo.Scope;

@Entity
@Access (AccessType.FIELD)
public class ScopeImpl extends NamedElementImpl implements Scope {

    @OneToMany (targetEntity = InterfaceObjectImpl.class, cascade = CascadeType.ALL, orphanRemoval = true)
    private Set<InterfaceObjectImpl> interfaceObjects = new LinkedHashSet<InterfaceObjectImpl>();

    @OneToMany (targetEntity = ScopeImpl.class, cascade = CascadeType.ALL, orphanRemoval = true, mappedBy = "parent")
    private Set<ScopeImpl> children = new LinkedHashSet<ScopeImpl>();

    @ManyToOne (targetEntity = ScopeImpl.class,
        cascade = {CascadeType.PERSIST, CascadeType.MERGE, CascadeType.REFRESH }, fetch = FetchType.LAZY)
    private ScopeImpl parent;

    @ManyToOne (targetEntity = ArchitectureImpl.class,
        cascade = {CascadeType.PERSIST, CascadeType.MERGE, CascadeType.REFRESH })
    private ArchitectureImpl architecture;

    @Basic
    private String path;

    public ScopeImpl() {
    }

    @SuppressWarnings ({"unchecked", "rawtypes" })
    public Set<InterfaceObject> getInterfaceObjects() {
        return (Set)interfaceObjects;
    }

    @SuppressWarnings ({"unchecked", "rawtypes" })
    public Set<InterfaceObjectImpl> getInterfaceObjectsImpl() {
        return (Set<InterfaceObjectImpl>)(Set)interfaceObjects;
    }

    public void setInterfaceObjects(Set<InterfaceObjectImpl> interfaceObjects) {
        this.interfaceObjects = interfaceObjects;
    }

    public void setChildren(Set<ScopeImpl> children) {
        this.children = children;
    }

    public void setParent(ScopeImpl parent) {
        this.parent = parent;
    }

    public Architecture getArchitecture() {
        return architecture;
    }

    public void setArchitecture(ArchitectureImpl architecture) {
        this.architecture = architecture;
    }

    public String getPath() {
        return path;
    }

    public void setPath(String path) {
        this.path = path;
    }

    public void addChild(ScopeImpl childScope) {
        children.add(childScope);
    }

    public void removeChild(Scope childScope) {
        children.remove(childScope);
    }

    public void addInterfaceObject(InterfaceObjectImpl interfaceObject) {
        interfaceObjects.add(interfaceObject);
    }

    public void removeInterfaceObjects(Predicate<? super InterfaceObject> condition) {
        interfaceObjects.removeIf(condition);
    }

    public void removeInterfaceObject(InterfaceObject io) {
        interfaceObjects.remove(io);
    }

    @Override
    public Set<InterfaceObject> getInputs() {
        return null;

    }

    @Override
    public Set<InterfaceObject> getOutputs() {
        return null;

    }

    @Override
    public Set<InterfaceObject> getLocals() {
        return null;

    }

    @Override
    public Set<InterfaceObject> getParameters() {
        return null;

    }

    @Override
    public Set<InterfaceObject> getAllInterfaceObjects() {
        return null;

    }

}

